﻿#pragma once

#include "Common\StepTimer.h"
#include "Common\DeviceResources.h"

#include "mp_wrap.h"

// Отрисовывает содержимое Direct2D и 3D на экране.
namespace dx3d
{
	class dx3dMain : public DX::IDeviceNotify
	{
	protected:
		MP_Emitter* cur;
		MP_Device_WRAP* magic_device;
	public:
		dx3dMain(const std::shared_ptr<DX::DeviceResources>& deviceResources);
		~dx3dMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRestored();

	private:
		// Кэшированный указатель на ресурсы устройства.
		std::shared_ptr<DX::DeviceResources> m_deviceResources;

		// Таймер цикла отрисовки.
		DX::StepTimer m_timer;
	};
}